"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ProteinVariantAnnotation(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import opencb as opencb_2_9_3

        return {
            "features": opencb_2_9_3.ProteinFeature,
            "substitutionScores": opencb_2_9_3.Score,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.ProteinFeature": opencb_2_9_3.ProteinFeature,
            "org.opencb.biodata.models.variant.avro.Score": opencb_2_9_3.Score,
            "org.opencb.biodata.models.variant.avro.ProteinVariantAnnotation": opencb_2_9_3.ProteinVariantAnnotation,
        }

    __slots__ = [
        "alternate",
        "features",
        "functionalDescription",
        "keywords",
        "position",
        "proteinId",
        "reference",
        "substitutionScores",
        "uniprotAccession",
        "uniprotName",
        "uniprotVariantId",
    ]

    def __init__(
        self,
        alternate=None,
        features=None,
        functionalDescription=None,
        keywords=None,
        position=None,
        proteinId=None,
        reference=None,
        substitutionScores=None,
        uniprotAccession=None,
        uniprotName=None,
        uniprotVariantId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.ProteinVariantAnnotation model.

        :param alternate:
        :type alternate: None | str
        :param features:
        :type features: None | list[ProteinFeature]
        :param functionalDescription:
        :type functionalDescription: None | str
        :param keywords:
        :type keywords: None | list[str]
        :param position:
        :type position: None | int
        :param proteinId:
        :type proteinId: None | str
        :param reference:
        :type reference: None | str
        :param substitutionScores:
        :type substitutionScores: None | list[Score]
        :param uniprotAccession:
        :type uniprotAccession: None | str
        :param uniprotName:
        :type uniprotName: None | str
        :param uniprotVariantId:
        :type uniprotVariantId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
